# Monk Conversion

Conversions of units and buildings.

## Unit Conversion

[Source](https://www.youtube.com/watch?v=UjOnv1YjHX0)

Converted units are frozen in the tech level they had when they were converted. There's no way to upgrade or improve them, but they will get some abilities (e.g. an enemy villager that has been converted in the dark age will be able to build a stable once you've advanced to the feudal age; even if the enemy culture doesn't even have stables). It appears that build/research/train abilities are the only thing that is not affected by the "conversion tech lock".

If monks are converted, they do keep the techs that affect their attributes but not ones that affect their abilities. For example, monks that are converted from a player who can convert buildings can no longer do this after the conversion.

As a general rule, these stats carry over from a conversion:

* Health Points
* Damage
* Speed
* Attack rate

## Building Conversion

[Source](https://www.youtube.com/watch?v=mAXY31QVs2Q)

Buildings are also frozen in tech level when converted. Besides that, they function just as normal as other buildings of the player and produce "normal" (not frozen in tech level) units.

Team bonuses are sometimes transferred over if they affect the stats of the building. For example, the faster building time from a Goth barrack is carried over but the cheaper infantry bonus is not. The higher population limit of Inca houses also seems to be a stat and stays if the house is converted.

Units inside a building are not converted and will ungarrison. The same is true for rams. Transport ships are a little bit complicated, since they do convert but the units inside don't. The player can choose to delete the transport ship, destroying all units inside or unload them at a shore so that the original owner regains control of them.

## Weird AoE2 Quirks

[Source](https://www.youtube.com/watch?v=_gjpDWfzaM0)

* If a converted unit is "replaced" by the game, e.g. a villager changing to a farmer, the stats are not frozen anymore.
* Converted siege units are only frozen in tech level until the new owner researches a technology that changes the units stats, e.g. chemistry. As soon as the research finishes, the units are replaced with ones that are on the same tech level as the player. Weirdly enough, Onagers are replaced if the player researches Heavy Scorpions but not if he researches Siege/Capped Rams.
* The flaming projectile caused by chemistry research is tied to the tech level of the owner but the +1 damage is kept, if the unit is converted.
